/* BitmapComponent.java */

import java.awt.*;
import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.image.MemoryImageSource;
import java.awt.Color;
import java.util.Arrays;
import java.util.Random;
import java.lang.*;

class BitmapComponent
extends Canvas
{
  class punkt{
    int x; int y;
  };
  boolean everyStep = false;  
  boolean mean = false;
  boolean median = true;

  punkt aktPunkt;

  Random generator = new Random();
  private Image img;
  int[] pixels;
  int[][] pixelMatrix;
  Color[] colorPixels;

        int w;
        int h;

  public BitmapComponent(String fname)
  {
 /*   pixels = greyValueImage(8);
    pixelMatrix = vecToMat(pixels,w,h);
    pixels = matToVec(pixelMatrix);
    img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
*/
    img = getToolkit().getImage(fname);
    MediaTracker mt = new MediaTracker(this);

    mt.addImage(img, 0);
    try {
      //Warten, bis das Image vollstdig geladen ist,
      //damit getWidth() und getHeight() funktionieren
      mt.waitForAll();
    } catch (InterruptedException e) {
      //nothing
    }
    w = img.getWidth(null);
    h = img.getWidth(null);

    pixels = bildAlsArray();
    img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
  }

   public int integerPower( int x, int y )
   {
      int val =0;
      if ( y == 0 )
         return 1;
      else if ( y == 1 )
	 return x;
      else   
	 val = x * x;

      for ( int counter = 3; counter <= y; counter ++ )
         val *= x;
	 return val;
   }

  public void greyValueImage(int s) {
    w = integerPower(2,s);
    h = integerPower(2,s);
    
    for (int j = 0; j < w*h; j++) {
      int c = generator.nextInt(254)+1;
      Color t = new Color(c,c,c);
      pixels[j] = t.getRGB();
    }
    img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
    paint(getGraphics());  
  }
 
  public void grayScaleImage(String fname)
  {
    img = getToolkit().getImage(fname);
    MediaTracker mt = new MediaTracker(this);

    mt.addImage(img, 0);
    try {
      //Warten, bis das Image vollstdig geladen ist,
      //damit getWidth() und getHeight() funktionieren
      mt.waitForAll();
    } catch (InterruptedException e) {
      //nothing
    }
    w = img.getWidth(null);
    h = img.getWidth(null);
    pixels = bildAlsArray();
    img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
    paint(getGraphics());  
  }
  
  public int[][] vecToMat(int[] p, int w, int h)
  {
    int[][] r = new int[h][w];
    for (int j = 0; j < h; j++) {
      for (int i = 0; i < w; i++) {
        r[j][i] = p[j * w + i];
      }
    }
  return r;
  }

  public int[] matToVec(int[][] p)
  {
    int[] r = new int[h*w];
    for (int j = 0; j < p.length; j++) {
      for (int i = 0; i < p[j].length; i++) {
        r[j * w + i] = p[j][i];
      }
    }
    return r;
  }



public void runHilbertScan()
{
  aktPunkt = new punkt();
  aktPunkt.x=0;
  aktPunkt.y=0;
  hilbertScan(8, 0);
  img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
  paint(getGraphics());  
}

public boolean imBild(punkt p,int rahmen)
{
  if ((p.x-rahmen > 0) && (p.y-rahmen > 0) && (p.y+rahmen < h) && (p.x+rahmen < w)) 
   return true; else return false;
}

  public void movePixel(int direction)
  {
    switch (direction) {
        case 1: //LINKS
          aktPunkt.x -= 1;
        break;
        case 3: //RECHTS
          aktPunkt.x += 1;
        break;
        case 0: //OBEN
          aktPunkt.y -= 1;
        break;
        case 2: //UNTEN
          aktPunkt.y += 1;
        break;
    }
    if (mean) {
      if (imBild(aktPunkt,2)) {
        int m = 0;
        for (int j = aktPunkt.y-2; j <= aktPunkt.y+2; j++) {
          for (int i = aktPunkt.x-2; i <= aktPunkt.x+2; i++) {
            m += (pixels[j * w + i]) & 0xff;
            //System.err.println(i);
          }
        }
	m = m/25;
        Color t = new Color(m,m,m);
        pixels[aktPunkt.y * w + aktPunkt.x] = t.getRGB();
      }
    }

    if (median) {
      if (imBild(aktPunkt,2)) {
        int[] m = new int[25];
        int l = 0;
        for (int j = aktPunkt.y-2; j <= aktPunkt.y+2; j++) {
          for (int i = aktPunkt.x-2; i <= aktPunkt.x+2; i++) {
            m[l] = (pixels[j * w + i]) & 0xff;
            l++;
            //System.err.println(i);
          }
        }
	Arrays.sort(m);
        Color t = new Color(m[12],m[12],m[12]);
        pixels[aktPunkt.y * w + aktPunkt.x] = t.getRGB();
      }
    }

    if (everyStep) {
      img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
      paint(getGraphics());
    }



  }

  //0: oben
  //1: links
  //2: unten
  //3: rechts

  public void hilbertScan(int level, int direction)
  {
    if (level == 1) {
      
      switch (direction) {
        case 1: //LINKS
          movePixel(3); //RECHTS
          movePixel(2); //RUNTER
          movePixel(1); //LINKS
        break;
        case 3: //RECHTS
          movePixel(1); //LINKS
          movePixel(0); //HOCH
          movePixel(3); //RECHTS
        break;
        case 0: //OBEN
	  movePixel(2); //RUNTER
          movePixel(3); //RECHTS
          movePixel(0); //OBEN
        break;
        case 2: //UNTEN
          movePixel(0); //HOCH
          movePixel(1); //LINKS
          movePixel(2); //UNTEN
        break;
      }
    } else {
      switch (direction) {
    case 1:
      hilbertScan(level-1,0);
      movePixel(3);
      hilbertScan(level-1,1);
      movePixel(2);
      hilbertScan(level-1,1);
      movePixel(1);
      hilbertScan(level-1,2);
      break;
    case 3:
      hilbertScan(level-1,2);
      movePixel(1);
      hilbertScan(level-1,3);
      movePixel(0);
      hilbertScan(level-1,3);
      movePixel(3);
      hilbertScan(level-1,0);
      break;
    case 0:
      hilbertScan(level-1,1);
      movePixel(2);
      hilbertScan(level-1,0);
      movePixel(3);
      hilbertScan(level-1,0);
      movePixel(0);
      hilbertScan(level-1,3);
      break;
    case 2:
      hilbertScan(level-1,3);
      movePixel(0);
      hilbertScan(level-1,2);
      movePixel(1);
      hilbertScan(level-1,2);
      movePixel(2);
      hilbertScan(level-1,1);
      break;
    } /* switch */
}
       //System.err.println(aktPunkt.x); 
  }

public void addUniformNoise() {
  for (int i = 0; i < w*h/10; i++) {
    int c = generator.nextInt(254)+1;
    int x = generator.nextInt(w);
    int y = generator.nextInt(h);
    Color t = new Color(c,c,c);
    pixels[y * w + x] = t.getRGB();

  }
  img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
  paint(getGraphics());
}

public void addGaussianNoise() {
  for (int i = 0; i < w*h/10; i++) {
    //System.err.println(Math.abs((int)Math.floor(generator.nextGaussian()*254/2.7183)));
    int c = Math.abs((int)Math.floor(generator.nextGaussian()*254/2.7183));
    int x = Math.abs((int)Math.floor(generator.nextGaussian()*w/2.71828));
    int y = Math.abs((int)Math.floor(generator.nextGaussian()*h/2.71828));
    Color t = new Color(c,c,c);
    pixels[y * w + x] = t.getRGB();

  }
  img = createImage(new MemoryImageSource(w, h, pixels, 0, w));
  paint(getGraphics());
}

  public int[] bildAlsArray() {
        int[] pixels = new int[w * h];
        PixelGrabber pg = new PixelGrabber(img, 1, 1, w, h, pixels, 0, w);
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            System.err.println("interrupted waiting for pixels!");
            return null;
        }
        if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
            System.err.println("image fetch aborted or errored");
            return null;
        }
    return pixels;
  }

  public void paint(Graphics g)
  {
    g.drawImage(img,1,1,this);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(
      img.getWidth(this),
      img.getHeight(this)
    );
  }

  public Dimension getMinimumSize()
  {
    return new Dimension(
      img.getWidth(this),
      img.getHeight(this)
    );
  }
}